#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Constants used in the input yaml
ORG_PARAM_NAME = "name"
ORG_PARAM_DESC = "description"
ORG_PARAM_DESC_GENUS = "genus"
ORG_PARAM_DESC_SPECIES = "species"
ORG_PARAM_DESC_SEX = "sex"
ORG_PARAM_DESC_STRAIN = "strain"
ORG_PARAM_DESC_COMMON_NAME = "common_name"
ORG_PARAM_DESC_ORIGIN = "origin"
ORG_PARAM_DESC_PICTURE_PATH = "picture_path"
ORG_PARAM_DESC_MAIN_SPECIES = "main_species"
ORG_PARAM_DATA = "data"
ORG_PARAM_DATA_GENOME_PATH = "genome_path"
ORG_PARAM_DATA_GENOME_CONTIG_PREFIX = "contig_prefix"
ORG_PARAM_DATA_TRANSCRIPTS_PATH = "transcripts_path"
ORG_PARAM_DATA_PROTEINS_PATH = "proteins_path"
ORG_PARAM_DATA_GFF_PATH = "gff_path"
ORG_PARAM_DATA_INTERPRO_PATH = "interpro_path"
ORG_PARAM_DATA_ORTHOFINDER_PATH = "orthofinder_path"
ORG_PARAM_DATA_BLASTP_PATH = "blastp_path"
ORG_PARAM_DATA_BLASTX_PATH = "blastx_path"
ORG_PARAM_DATA_GENOME_VERSION = "genome_version"
ORG_PARAM_DATA_OGS_VERSION = "ogs_version"
ORG_PARAM_SERVICES = "services"
ORG_PARAM_SERVICES_PROJECT_URL = "project_url"
ORG_PARAM_SERVICES_BLAST = "blast"
ORG_PARAM_SERVICES_GO = "go"

# Constants used in the config yaml file
CONF_ALL_HOSTNAME = "hostname"
CONF_ALL_HTTP_PORT = "http_port"
CONF_ALL_HTTPS_PORT = "https_port"
CONF_ALL_PROXY_IP = "proxy_ip"
CONF_ALL_AUTH_DOMAIN_NAME = "authentication_domain_name"
CONF_ALL_AUTHELIA_CONFIG_PATH = "authelia_config_path"
CONF_ALL_AUTHELIA_SECRETS_ENV_PATH = "authelia_secrets_env_path"
CONF_ALL_AUTHELIA_DB_POSTGRES_PASSWORD = "authelia_db_postgres_password"
CONF_GALAXY_DEFAULT_ADMIN_EMAIL = "galaxy_default_admin_email"
CONF_GALAXY_DEFAULT_ADMIN_USER = "galaxy_default_admin_user"
CONF_GALAXY_DEFAULT_ADMIN_PASSWORD = "galaxy_default_admin_password"
CONF_GALAXY_DEFAULT_ADMIN_KEY = "galaxy_default_admin_key"
CONF_GALAXY_CONFIG_REMOTE_USER_MAILDOMAIN = "galaxy_config_remote_user_maildomain"
CONF_GALAXY_PERSIST_DATA = "galaxy_persist_data"
CONF_TRIPAL_PASSWORD = "tripal_password"
CONF_TRIPAL_BANNER_PATH = "tripal_banner_path"
CONF_TRIPAL_THEME_NAME = "tripal_theme_name"
CONF_TRIPAL_THEME_GIT_CLONE = "tripal_theme_git_clone"
CONF_JBROWSE_MENU_URL = "jbrowse_menu_url"

# Data
FILENAME_SUFFIX_TRANSCRIPTS = "transcripts_gff.fasta"
FILENAME_SUFFIX_PROTEINS = "proteins.fasta"
FILENAME_SUFFIX_INTERPRO = "interproscan.xml"
FILENAME_SUFFIX_BLASTP = "diamond_blastp_vs_uniref90.xml" # Temporary constant: this value should be in the organism input file
FILENAME_SUFFIX_BLASTX = "diamond_blastx_vs_uniref90.xml" # Temporary constant: this value should be in the organism input file
FILENAME_SUFFIX_ORTHOFINDER = "orthologous_one2one_vs_Ec32.tsv" # Temporary constant: this value should be in the organism input file
DATA_DATE = "2021-02-24" # Temporary constant: this value should be in the organism input file, for each data

# default config file
DEFAULT_CONFIG = "examples/config"

# Galaxy tools
GET_ORGANISMS_TOOL = "toolshed.g2.bx.psu.edu/repos/gga/chado_organism_get_organisms/organism_get_organisms/2.3.4+galaxy0"
DELETE_ORGANISMS_TOOL = "toolshed.g2.bx.psu.edu/repos/gga/chado_organism_delete_organisms/organism_delete_organisms/2.3.4+galaxy0"

# Galaxy library
HOST_DATA_DIR='src_data'
CONTAINER_DATA_DIR_ROOT='/project_data'
GALAXY_LIBRARY_NAME = 'Project Data'
GALAXY_LIBRARY_DESC = 'Data for current genome annotation project'

REQUIRED_PARAMETERS = [CONF_ALL_HOSTNAME, CONF_ALL_HTTP_PORT, CONF_GALAXY_DEFAULT_ADMIN_EMAIL, CONF_GALAXY_DEFAULT_ADMIN_USER,
					   CONF_GALAXY_DEFAULT_ADMIN_PASSWORD, CONF_GALAXY_DEFAULT_ADMIN_KEY, CONF_TRIPAL_PASSWORD,
					   CONF_GALAXY_CONFIG_REMOTE_USER_MAILDOMAIN]
